﻿<?php
/**
 * Plugin Name: Embed bare image links
 * Plugin URI: http://www.diegobiota.com/tecnologias-web/wordpress/embed-bare-image-links-plugin/
 * Description: Converts bare image links inserted in the post content into HTML tagged images. Only applies into pictures not tagged by the user. 
 * Version: 1.0
 * Author: Diego Biota
 * Author URI: http://diegobiota.com
 * License: GPL2
 */

 
 /*  Copyright 2014  Diego Biota Romeo  (email : diegobiota@gmail.com)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License, version 2, as 
    published by the Free Software Foundation.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/
 
 
// no direct links allowed
defined('ABSPATH') or die("No script kiddies please!");



////////////////////////////////////////////////CORE FUNCTIONALITY///////////////////////

//Procesamos el contenido de un post, 
//antes de guardarlo en la base de datos
//para buscar la url de una imagen.
//(no cogera los que ya parezcan insertados con HTML, 
//o sea, que comiencen por "). Les pondremos la etiqueta 
//de <img> antes de devolver el contenido

function convert_linked_pics( $data , $postarr ) {
	
	$content = $data['post_content'];
 
    //buscamos en el content todas las incidencias de las urls de imagen.
	$content = preg_replace_callback(
        '/[^"](http|https):\/\/\S*(.jpg|.jpeg|.png|.gif)/',   //encuentra las cadenas que empiecen por cualquier caracter menos ", siga con http, luego cualquier caracter menos espacio, y despues cualquiera de las extensiones de imagen.
        function ($matches) {
			//ahora extraeremos el primer caracter, y lo conservaremos en la sustitucion
			$primer = substr($matches[0], 0, 1);  
			$resto = substr($matches[0], 1); 
            return $primer.'<img class="embedded-img" src="'.$resto.'">';  
        },
        $content
    );  

	$data['post_content'] = $content;
	
	return $data;
	
}
add_filter( 'wp_insert_post_data', 'convert_linked_pics', '99', 2 ); 





?>